<template>
    <div class='portlet portal-components-operation ' :style="{'height': isAdaptiveSize ? 'calc(100% - 16px)' : getHeight,}">
        <div class="portlet-without-title">
            <app-actionbar :viewState="viewState" :uiService="appUIService" :items="actionBarModelData" @itemClick="handleItemClick"></app-actionbar>
        </div>
    </div>
</template>
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util, ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import IBIZOrderService from '@/service/ibizorder/ibizorder-service';
import PortalComponentsOperationService from './portal-components-operation-portlet-service';

import IBIZOrderUIService from '@/uiservice/ibizorder/ibizorder-ui-service';
import UIService from '@/uiservice/ui-service';
import { Environment } from '@/environments/environment';


@Component({
    components: {
      
    }
})
export default class IBIZOrderPortalComponentsOperationBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof PortalComponentsOperationBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof PortalComponentsOperationBase
     */
    public getControlType(): string {
        return 'PORTLET'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof PortalComponentsOperationBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {PortalComponentsOperationService}
     * @memberof PortalComponentsOperationBase
     */
    public service: PortalComponentsOperationService = new PortalComponentsOperationService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZOrderService}
     * @memberof PortalComponentsOperationBase
     */
    public appEntityService: IBIZOrderService = new IBIZOrderService({ $store: this.$store });

    /**
     * 界面UI服务对象
     *
     * @type {IBIZOrderUIService}
     * @memberof PortalComponentsOperationBase
     */  
    public appUIService:IBIZOrderUIService = new IBIZOrderUIService(this.$store);
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public dashboard_sysportlet3_u236cbdc_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
        curUIService.IBIZOrder_FUIAction1(datas,contextJO, paramJO,  $event, xData,this,"IBIZOrder");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public dashboard_sysportlet3_ued71017_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZOrderUIService  = new IBIZOrderUIService();
        curUIService.IBIZOrder_open_document(datas,contextJO, paramJO,  $event, xData,this,"IBIZOrder");
    }


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof PortalComponentsOperationBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof PortalComponentsOperationBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 长度
     *
     * @type {number}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public height?: number;

    /**
     * 宽度
     *
     * @type {number}
     * @memberof PortalComponentsOperationBase
     */
    @Prop() public width?: number;

    /**
     * 门户部件类型
     *
     * @type {number}
     * @memberof PortalComponentsOperationBase
     */
    public portletType: string = 'actionbar';

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof PortalComponentsOperationBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;

    /**
     * 操作栏模型数据
     *
     * @returns {any[]}
     * @memberof PortalComponentsOperationBase
     */
    public actionBarModelData:any[] =[
        { viewlogicname:"dashboard_sysportlet3_u236cbdc_click",
        actionName:"编辑",
        icon:"",
        visabled:true,disabled:false
        },
        { viewlogicname:"dashboard_sysportlet3_ued71017_click",
        actionName:"打开文档",
        icon:"",
        visabled:true,disabled:false
        }
    ];

    /**
     * 触发界面行为
     *
     * @memberof PortalComponentsOperationBase
     */
    public handleItemClick($event:any){
      let data: any = $event.params && Object.keys($event.params).length > 0 ? $event.params : null;
        if(Object.is($event.tag,'dashboard_sysportlet3_u236cbdc_click')){
            this.dashboard_sysportlet3_u236cbdc_click(data, $event.tag, $event.event);
        }
        if(Object.is($event.tag,'dashboard_sysportlet3_ued71017_click')){
            this.dashboard_sysportlet3_ued71017_click(data, $event.tag, $event.event);
        }
    }

    /**
     * 界面行为模型数据
     *
     * @memberof PortalComponentsOperationBase
     */
    public uiactionModel: any = {
        fuiaction1: {name: 'fuiaction1', actiontarget: 'NONE', caption: '', disabled: false, type: 'DEUIACTION', visabled: true, noprivdisplaymode: 2, dataaccaction: '', uiaction: { tag: 'FUIAction1', target: 'NONE' } },
        open_document: {name: 'open_document', actiontarget: 'NONE', caption: '', disabled: false, type: 'DEUIACTION', visabled: true, noprivdisplaymode: 2, dataaccaction: '', uiaction: { tag: 'open_document', target: 'NONE' } },
    }


    /**
     * 是否自适应大小
     *
     * @returns {boolean}
     * @memberof PortalComponentsOperationBase
     */
    @Prop({default: false})public isAdaptiveSize!: boolean;

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof PortalComponentsOperationBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof PortalComponentsOperationBase
     */
    public getData(): any {
        return {};
    }

    /**
     * 获取高度
     *
     * @returns {any[]}
     * @memberof PortalComponentsOperationBase
     */
    get getHeight(){
        if(!this.$util.isEmpty(this.height) && !this.$util.isNumberNaN(this.height)){
            if(this.height == 0){
                return 'auto';
            }else{
                return this.height+'px';
            }
        }else{
            return '100px';
        }
    }

    /**
     * 刷新
     *
     * @memberof PortalComponentsOperationBase
     */
    public refresh(args?: any) {
    }

    /**
     * vue 生命周期
     *
     * @memberof PortalComponentsOperationBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof PortalComponentsOperationBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if(Object.is(tag, "all-portlet") && Object.is(action,'loadmodel')){
                   this.calcUIActionAuthState(data);
                }
                if (!Object.is(tag, this.name)) {
                    return;
                }
                const refs: any = this.$refs;
                Object.keys(refs).forEach((_name: string) => {
                    this.viewState.next({ tag: _name, action: action, data: data });
                });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof PortalComponentsOperationBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof PortalComponentsOperationBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }


    /**
     * 计算界面行为权限
     *
     * @memberof PortalComponentsOperationBase
     */
    public calcUIActionAuthState(data:any = {}) {
        //  如果是操作栏，不计算权限
        if(this.portletType && Object.is('actionbar', this.portletType)) {
            return;
        }
        let _this: any = this;
        let uiservice: any = _this.appUIService ? _this.appUIService : new UIService(_this.$store);
        if(_this.uiactionModel){
            ViewTool.calcActionItemAuthState(data,_this.uiactionModel,uiservice);
        }
    }

}
</script>

<style lang='less'>
@import './portal-components-operation-portlet.less';
</style>

